/* A SIMPLE RANDOM MAP - by Author - Version 1.0 */
include "mercenaries.xs"; /* This loads the mercenaries needed for regular gameplay RMS! */
void main(void) { /* This is the main entry point for your RMS! */
rmSetStatusText("",0.01); /* This is the value for the map generation progress bar when starting the game */
/* (value 0.00 - 1.00) */
int myTiles = 8000; /* This is a typical variable for the map size */
if(cMapSize == 1) { /* This if function checks if map was selected normal or large. cMapSize (1=large, 0=normal) */
myTiles = 12000; /* This is a typical variable for the map size, when map chosen large! */
rmEchoInfo("Large map"); /* This is an output information only for the RMS debugger! */
}
int mySize = 2.0*sqrt(cNumberNonGaiaPlayers * myTiles);
/* Above the size of the map will be redefined. */
/* Since the map size is now proportional to the square root of the player number, */
/* the map area will be proportional to the player number! */
rmEchoInfo("Map size="+mySize+"m x "+mySize+"m"); /* Another output information only for the RMS debugger! */
rmSetMapSize(mySize,mySize); /* This command will build the map size */
rmSetSeaLevel(0); /* This command will set the sea level in meters height */
rmSetSeaType("Amazon River"); /* This command will set the sea texture, if there is water */
rmTerrainInitialize("texas\ground2_tex",4); /* This command will set the map as water or land map */
/* If you want water, replace "texas\ground2_tex",4 with "water",0 and the defined SetSeaType texture will be used! */
rmSetStatusText("",0.20); /* This is the next value for the map generation progress bar, the bar increases */
/* Areas can be added here: */
rmSetStatusText("",0.40); /* This is the next value for the map generation progress bar, the bar increases */
/* Players are added here: */
/* The following command will align the place for the player areas randomly in a circle: */
rmPlacePlayersCircular(0.3, 0.3, rmDegreesToRadians(0.0));
/* Now we start a loop for every player: */
for(i = 1; <= cNumberNonGaiaPlayers) {
/* We define an area for every player: */
int id = rmCreateArea("Player"+i);
/* We define the height of each player area: */
rmSetAreaBaseHeight(id,4.3);
/* We define the coherence of each player area (1.0 = smooth circe, 0.0 = roughest circle): */
rmSetAreaCoherence(id,1.0);
/* We define the height blend of each player area: */
rmSetAreaHeightBlend(id,2);
/* We define the center of the player area: */
rmSetAreaLocPlayer(id,i);
/* We define the size of the player area: */
rmSetAreaSize(id,0.001,0.001);
/* We define the area of the player area: */
rmSetPlayerArea(i,id);
/* We define the terrain of the player area: */
rmSetAreaTerrainType(id,"sonora\ground1_son");
/* We have defined all neccessary variables for the player area, now we can build it: */
rmBuildArea(id);
/* We 1. define a new object, 2. we add a starting TownCenter to it, 3. we place/build it onto the map: */
int towncenterID = rmCreateObjectDef("Starting Towncenter"+i);
rmAddObjectDefItem(towncenterID,"TownCenter",1,0.0);
rmPlaceObjectDefAtLoc(towncenterID,i,rmPlayerLocXFraction(i),rmPlayerLocZFraction(i),1);
}
rmSetStatusText("",0.60); /* This is the next value for the map generation progress bar, the bar increases */
/* Objects can be added here */
rmSetStatusText("",0.80); /* This is the next value for the map generation progress bar, the bar increases */
/* Triggers can be added here */
rmSetStatusText("",1.00); /* This is the next value for the map generation progress bar, the bar is full! */
}
/* This is the end of our xs-file! */

